 program Test_MOD;

 {(C) Charles Attard. April 1997}
 {Sample source to play modules}

 {$M 8000,0,655360}
  uses
      Crt,Dos,SB,SysProc,PlayMODs,Errors_E;

  var
     Nom_1,Err,Path : string[64];
     Cr             : char;
     I,Mode,LastBack,
     X,Y            ,
     CF,Min,Max     : word;
     TDir           : SearchRec;
     Data           : MiscData;
     Shrink_Ok      : boolean;

 procedure Write_Message;
  begin
       writeln('Playing ',Path+TDir.Name);
       writeln('Hit ESC to abort, D for DOS shell, Enter for next ...');
       X:=WhereX;
       Y:=WhereY;
  end;

  begin
       DMASize:=16000;
       InitHardware;
       {Display error if any}
       if Err_Type>0 then
        begin
         writeln(Error_Msg(Err_Type));
         halt(Err_Type);
        end;
       {Search file}
       if ParamCount=0 then
        begin
             writeln('Please enter a module name ...');
             writeln('for example: TESTMOD GOODMOD.S3M');
             writeln('             TESTMOD GOODMOD');
             writeln('             TESTMOD *.S3M');
             writeln('             TESTMOD *');
             exit;
        end;
       Nom_1:=ParamStr(1);
       LastBack:=0;
       for I:=1 to length(Nom_1) do
        begin
         Nom_1[I]:=UpCase(Nom_1[I]);
         if Nom_1[I]='\' then LastBack:=I;
        end;
       if pos('.',Nom_1)=0 then
        begin
             Nom_1:=Nom_1+'.*';
        end;
       if LastBack=0 then
        GetDir(0,Path)
       else
        Path:=copy(Nom_1,1,LastBack-1);
       Path:=Path+'\';
       FindFirst(Nom_1,$20,TDir);
       if DosError>0 then
        begin
             write(Error_Msg(DosError));
             halt(DosError);
        end;

       {play modules}
       repeat

       Cr:=#0;

       Load_MODule(Path+TDir.Name);
       if Err_Type>0 then
        begin
             writeln(Path+TDir.Name);
             writeln(Error_Msg(Err_Type));
        end
       else
        begin
         {set output mode}
	 {0,3 8-bit stereo, 16-bit mono
	  1   16-bit stereo
	  2   8-bit mono}
         {returns Min frequency available,
                  Max frequency available}
         Mode:=1;
         Set_Output_Mode(Mode,Min,Max);
         {set desired output frequency,
          returns closest output frequency}
         Set_Output_Freq(44100,CF);
         {enable oversampling}
         Set_LDI(true);
         {set digital amplification using the number of tracks of the
          current module}
         Get_Module_Status(Data);
         Set_Ampl_Num(trunc(42+(Data[5]-3)*144/28));
         {set module looping to 'forbidden'}
         {0 allowed}
         {1 forbidden}
         {2 forced}
         Set_Loop_Mode(1);
         {enable digital low-pass filter}
         Set_Filter(true);
         {set filter iterations to 1}
         Set_Iter_Filtre(1);
         {set default panning}
         Set_Default_Pan(42);
         {set fade out delay to 1 ms}
         Set_Fade_Out_Delay(1);
         {set master volume to maximum}
         Set_Master_Volume(64);

         Write_Message;

         Start_MODule;

         repeat

         delay(100);
         GotoXY(X,Y);
         write(CPU_Load);

         if Keypressed then
          begin
               Cr:=ReadKey;
               if (Cr='d') or (Cr='D') then
                begin
                     heap_shrink(Shrink_OK);
                     if Shrink_Ok then
                      begin
                       swapvectors;
                       exec(GetEnv('COMSPEC'),'');
                       swapvectors;
                       heap_expand;
                       if DosError>0 then
                        begin
                         writeln('DOS error ',DosError);
                        end
                       else
                        Write_Message;
                      end;
                end;
          end;

         until (Cr in [#27,#13,#32]) or not Module_Playing;

         Stop_MODule;

       end;

       if Cr<>#27 then FindNext(TDir);

       until (DosError>0) or (Cr=#27);

       CloseHardware;

  end.
